#ifndef __MACROS_H
#define __MACROS_H
//------------------------------------------------------------------------------

#define CLI()	asm("cli")
#define NOP()	asm("nop")
#define SEI()	asm("sei")
#define SLEEP() asm("sleep")
#define WDR() 	asm("wdr")
#define RESET() {asm("ldi r30,0"); asm("ldi r31,0"); asm("ijmp");}

#define BIT(x) (1 << (x)) // Bitwert definieren
#define HI(x) ((x) >> 8) // Highbyte von 16-Bit Wert
#define ABS(x) ((x >= 0) ? x : -x) // Absolutwert von x

#define SET_BIT(byte,bit) (byte |= bit) // Bit y in x setzen
#define CLR_BIT(byte,bit) (byte &= ~bit) // Bit y in x lschen
#define IS_SET(byte,bit) (byte & bit) // ist > 0, wenn bit = 1
#define IS_CLR(byte,bit) (!IS_SET(byte,bit)) // ist > 0, wenn bit = 0

#define HI_HEX(x) ("0123456789ABCDEF" [x >> 4]) // Oberes Nibble als Hex
#define LO_HEX(x) ("0123456789ABCDEF" [x & 0x0F]) // Unteres Nibble als Hex
//------------------------------------------------------------------------------

#endif
