/*#######################################################################################
Erzeugen eines RC Summen Signals 

Copyright (C) 2006 Ulrich Radig

#######################################################################################*/

#include "rc.h"


U08 rc_channel_counter = 0;
U16 rc_channel_sum;
volatile S08 rc_ch[RC_MAX_CHANNEL];

//############################################################################
//Timer Interrupt Service Routine
ISR (TIMER1_OVF_vect)
//############################################################################
{
  U16 tmp;
  PORTC ^= (1<<PINC0);
  
  if (!(PORTC & (1<<PINC0)))
  {
    TCNT1 = TIMER_VALUE_MAX - (MS0_5);
  }
  else
  {
    if (rc_channel_counter == RC_MAX_CHANNEL)
    {
      TCNT1 = TIMER_VALUE_MAX - rc_channel_sum;
      rc_channel_sum = RC_REPETITION_TIME - (RC_MAX_CHANNEL*MS0_5);
      rc_channel_counter = 0;
    }
    else
    {
      if (rc_ch[rc_channel_counter] > RC_MAX_VALUE)
      {
        rc_ch[rc_channel_counter] = RC_MAX_VALUE;
      }
      if (rc_ch[rc_channel_counter] < RC_MIN_VALUE)
      {
        rc_ch[rc_channel_counter] = RC_MIN_VALUE;
      }
      tmp = (RC_OFFSET_TIME + (5 * rc_ch[rc_channel_counter]));
      TCNT1 = TIMER_VALUE_MAX - tmp;
      rc_channel_sum -= tmp;
      rc_channel_counter ++;
    }
  }
}

//############################################################################
//Diese Routine startet und inizialisiert den Timer
void rc_sum_init (void)
//############################################################################
{
    //Interrupt for the Clock enable  
    TIMSK1 |= (1<<TOIE1);
    //Setzen des Prescaler auf 8
    TCCR1B |= (1<<CS11); 
    TCNT1 = TIMER_VALUE_MAX - RC_REPETITION_TIME;
    return;
}




