#ifndef __USART_H
#define __USART_H
//------------------------------------------------------------------------------

#include "typedefs.h"
//#include <avr/signal.h>
#include <avr/interrupt.h>
#include <avr/io.h>
#include "support.h"

//------------------------------------------------------------------------------

#define BUFFER_SIZE 82
#define LF 10
#define CR 13
#define ESC 27
#define SPC 32
//------------------------------------------------------------------------------

extern volatile BOOL usart_ready;
extern volatile U08 usart_buffer[];
//------------------------------------------------------------------------------

void usart_init(void); 
void usart_reset(void);
void usart_write_char(U08 data);
void usart_write_str(pU08 str);
void usart_writeln_flash_str(const U08 *str);
void usart_writeln_str(pU08 str);
void usart_write_U08(U08 data); // Byte ausgeben
void usart_write_U16(U16 data); // Int ausgeben
void usart_write_U08_hex(U08 data); // Byte hexadezimal ausgeben
// Byte dezimal oder hexadezimal ausgeben
void usart_write_U08_dec_hex(U08 data,BOOL space,BOOL crlf); 
//SIGNAL (SIG_UART0_RECV);
//void usart_rx_isr(void);
//------------------------------------------------------------------------------

#endif
